'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _babelCore = require('babel-core');

var _convertSourceMap = require('convert-source-map');

var _convertSourceMap2 = _interopRequireDefault(_convertSourceMap);

var defaults = {
  extensions: ['.js', 'babel.js', '.es6', '.es6.js', '.jsx'],
  sourceMaps: true
};

exports['default'] = function (_options) {
  var options = undefined,
      extensions = undefined;

  function setup() {
    options = Object.assign({}, defaults, _options);

    // remove our special option
    if (options.extensions) {
      extensions = options.extensions;
      delete options.extensions;
    }

    // the remaining options object is suitable for giving to babel.
  }

  return function exhibitBabel(path, contents) {
    if (!options) setup();

    // pass non-JS files straight through
    var isJS = undefined,
        jsFilename = undefined;
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = extensions[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var extension = _step.value;

        if (path.substr(-extension.length) === extension) {
          isJS = true;
          jsFilename = path.substring(0, path.length - extension.length) + '.js';
          break;
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator['return']) {
          _iterator['return']();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    if (!isJS) return contents;

    var source = contents.toString();
    var result = undefined;

    try {
      result = (0, _babelCore.transform)(source, options);
    } catch (error) {
      console.log('ERROR!!!');
      console.log(error.loc);

      // todo: remove the "(line:column)" from end of message

      throw new this.SourceError({
        message: error.message,
        path: path,
        contents: source,
        line: error.loc ? error.loc.line : null,
        column: error.loc ? error.loc.column : null
      });
    }

    if (options.sourceMaps) {
      // console.log('result.map', typeof result.map, result.map);

      var comment = _convertSourceMap2['default'].fromObject(result.map).setProperty('sources', [path]).toComment();

      return _defineProperty({}, jsFilename, result.code + '\n' + comment);
    }

    return _defineProperty({}, jsFilename, result.code);
  };
};

module.exports = exports['default'];